#ifndef _LCD_DRAW_H
#define _LCD_DRAW_H

#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>

extern Adafruit_PCD8544 display;

#include "leaderboard.h"

#define NUM_MENU_ITEMS 3
#define BUZZER_PIN A3

/* Setup the Adafruit_PCD8544 display */
void setup_display();

/* Draws the main menu, with the given item as selected */
void draw_main_menu(int selected_menu_item);

/* Draws the singleplayer screen */
void draw_singleplayer(int score, int time_left, int lives);

/* Draws the current state of the leaderboard */
void draw_leaderboard(Leaderboard leaderboard);

/* Draws the game over page; if singleplayer, shows score, otherwise, shows which player won */
void draw_game_over(int to_display, bool is_singleplayer);

/* Draws a bitmap arrow corresponding to the given direction */
void draw_direction(int direction);

/* Display the "Get ready" page at the start of a level */
void display_start_level();

/* Display the screen for the player that is creating the sequence in multiplayer */
void display_player1_screen(int player_idx, int gestures_left);

/* Display the screen for the player that is reproducing the sequence in multiplayer */
void display_player2_screen(int time_left, int lives, int turn);

/* Clears the display */
void clear_display();

#endif
