#ifndef _LEADERBOARD_H
#define _LEADERBOARD_H

#define BUZZER_PIN A3

#define LEADERBOARD_ENTRIES 10
#define LEADERBOARD_ENTRIES_PER_PAGE 3

class Leaderboard {
public:
  int scores[LEADERBOARD_ENTRIES];
  int start_idx;
  int entries;
  int entries_per_page;
  
  Leaderboard();

  /* Get the top scores from the SD card */
  void getScores();

  /* Add the given score to the leaderboard and save to the SD card
   * if the score is good enough
   */
  void addScore(int score);

  /* Resets the attributes of the leaderboard (when going back to the main menu) */
  void resetAttributes();

  /* Scroll up */
  void pageUp();

  /* Scroll down */
  void pageDown();
};

#endif
