#ifndef _MULTIPLAYER_H
#define _MULTIPLAYER_H

#define MAX_SEQ_LEN 30

class Multiplayer {
public:
  bool started;

  int time_left;
  int game_level;

  int lives[2];
  int winner;

  int generated_sequence[MAX_SEQ_LEN];
  int player1_input_idx;
  int player2_input_idx;

  volatile bool is_game_over;

  volatile bool display_changed;

  Multiplayer();

  /* Functions for handling the gestures inputted by the players */
  void handlePlayer1Gesture();
  void handlePlayer2Gesture(int player2_idx);

  /* Start the game with the given parameters */
  void start(int start_time, int start_lives);

  /* Handler called in the timer interrupt in the main file */
  void handleTimerInterrupt();

  /* Play a turn; turn indicates which player has to create the sequence */
  void playTurn(int turn);

  /* Play a whole game, with the given start time for the first round */
  void play(int start_time);

  /* Function called when a game ends */
  void finishGame();

  /* Resets the state of the multiplayer game */
  void resetAttributes();
};

#endif
