#ifndef _SINGLEPLAYER_H
#define _SINGLEPLAYER_H

#include "leaderboard.h"

#define MAX_SEQ_LEN 30

#define BUZZER_PIN A3

class Singleplayer {
public:
  bool started;

  int time_left;
  int lives;
  int game_level;
  int score;

  int generated_sequence[MAX_SEQ_LEN];
  int user_input_idx;

  volatile bool is_game_over;

  volatile bool display_changed;

  Leaderboard leaderboard;

  Singleplayer(Leaderboard leaderboard);

  /* Functions for handling the gestures inputted by the player */
  void handleGesture();

  /* Display the generated sequence of gestures */
  void displaySequence();

  /* Start the game with the given parameters */
  void start(int start_time, int start_lives);

  /* Handler called in the timer interrupt in the main file */
  void handleTimerInterrupt();

  /* Initialises the current level */
  void initialiseLevel(int start_time);

  /* Plays the current level */
  void playLevel(int start_time);

  /* Play a whole game, with the given start time for the first round */
  void play(int start_time);

  /* Function called when a game ends */
  void finishGame();

  /* Resets the state of the singleplayer game */
  void resetAttributes();
};

#endif
